''' <summary>
''' This modules contains methods to help with encoding and decoding special
''' characters in JavaScript
''' </summary>
''' <author>Mikael Levn</author>
''' <created>2007-12-10</created>
''' <version>1.0.0</version>
''' <remarks></remarks>
Public Module JavaScriptHelper

    ''' <summary>
    ''' Encodes ASCII newline and tab chartacters in a text to work with JavaScript
    ''' </summary>
    ''' <param name="text"></param>
    ''' <returns>Returns a string with newline and tab characters replaced with their JavaScript encoded equivalent</returns>
    ''' <remarks></remarks>
    Public Function JavaScriptEncodeText(ByVal text As String) As String
        text = text.Replace(Environment.NewLine, "\r\n")
        text = text.Replace(Microsoft.VisualBasic.Chr(13), "\r")
        text = text.Replace(Microsoft.VisualBasic.Chr(10), "\n")
        text = text.Replace(Microsoft.VisualBasic.Chr(9), "\t")
        Return text
    End Function

    ''' <summary>
    ''' Decodes JavaScript encoded newline and tab characters to normal ASCII characters
    ''' </summary>
    ''' <param name="text">The encoded text to be decoded</param>
    ''' <returns>Returns a string with JavaScript encoded newline and tab replaced with ASCII characters</returns>
    ''' <remarks></remarks>
    Public Function JavaScriptDecodeText(ByVal text As String) As String
        text = text.Replace("\r\n", Environment.NewLine)
        text = text.Replace("\r", Microsoft.VisualBasic.Chr(13))
        text = text.Replace("\n", Microsoft.VisualBasic.Chr(10))
        text = text.Replace("\t", Microsoft.VisualBasic.Chr(9))
        Return text
    End Function

End Module
